/**
 * plugins namespace
 * @param  $ jQuery namespace
 */
(function($){
	if(!$.jsonStoreDB_plugins){
		$.jsonStoreDB_plugins = {
			indexedDB : {},
			webSQL:{},
			localStorage:{}
		}
	}
})(jQuery);


/**
 * jsonStore
 * @param   $ jQuery namespace
 */
(function($){

	var plugin = $.jsonStoreDB_plugins.indexedDB;

	$.extend({
		"jsonStoreDB" : function(dbName, opts) {
			var defaults = {};
			$.extend(defaults,opts);

			if(!dbName){

				return plugin.getDatabaseNamesPromise();
			}

			if(defaults.deleteDb === true){
	
				return plugin.getDeleteDbPromise(dbName);
			}else{

				return {
					"objectStore" : function(storeName) {
						return plugin.getObjectStorePromise(dbName, storeName);
					},

					"deleteStore" : function(storeName) {
						return plugin.getDeleteObjectStorePromise(dbName, storeName);
					},

					"objectStoreNames" : function() {
						return plugin.getObjectStoreNamesPromise(dbName);
					} 
				};
			}
		}
	})
})(jQuery);