(function($){

	function unixtime(){
		var d = new Date();
		return parseInt(d.getTime() / 1000, 10);
	}

	function uuid() {
	    var S4 = function() {
	       return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
	    };
	    return (S4()+S4()+S4()+S4()+S4()+S4()+S4()+S4());
	}

	var DBkeyGen = function(dbName, objectStore){
		return '__jsonStorageDB_' + dbName + '_' + objectStore;
	}

	var getObject = function(key){
		var s = localStorage(key);
		if(s){
			return JSON.parse(s);
		}
		return null;
	}

	var createObjectFromString = function(s, k){
		return {
			key: k,
			version: parseInt(s.substring(0,10), 10),
			timestamp: parseInt(s.substring(10, 20), 10),
			item: JSON.parse(s.substring(20))
		}
	}

	var createStringFromObject = function(o){
		return  lpad(o.version, 10) + lpad(o.timestamp, 10) + JSON.stringify(o.item);
	}

	var getDocVersion = function(key){
		return parseInt(localStorage.getItem(key).substring(0,10), 10);
	}

	function lpad(s,l){
		var str = '' + s;
		while (str.length < l){
			str = '0' + str;
		}
		
		return str;
	}
	
	$.extend({
		"jsonStorageDB_engine" : function() {
			return {
				bases: {},
				keys: {},
				
				create: function(dbName, objectStoreName){
					if(!this.bases[dbName]){
						this.bases[dbName] = {};
					}
					
					if(!this.keys[dbName]){
						this.keys[dbName] = {};
					}

					if(!this.bases[dbName][objectStoreName]){
						this.bases[dbName][objectStoreName] = {};
						this.keys[dbName][objectStoreName] = [];
						var self = this;

						DBkey = DBkeyGen(dbName, objectStoreName);
						s = localStorage.getItem(DBkey);
						
						if(s){
							keys = JSON.parse(s);
							$.each(keys, function(i, k){
								self.bases[dbName][objectStoreName][k] = createObjectFromString(localStorage.getItem(k), k);
								self.keys[dbName][objectStoreName].push(k);
							})
						}
					}
				},
				
				getKeys: function(objectStore){
					var key = DBkeyGen(this.dbName, objectStore);
					var result = getObject(key);
					return result;
				},
				
				transaction: function(dbName, objectStoreName) {
					
					this.create(dbName, objectStoreName);
					var self = this;
					
					return {
						save : function(data, key, force){

							var store = self.bases[dbName][objectStoreName];
							var keys = self.keys[dbName][objectStoreName];
							var DBkey = DBkeyGen(dbName, objectStoreName);
							
							if(!key){
								if(data.key){
									key = data.key;
									delete(data.key);
								}else{
									key = uuid();
								}
							}
							
							return $.Deferred(function(dfd){
								if(!data){
									dfd.reject('data is: ' + typeof data, key);
									return;
								}
								if(store[key]){
									var curVersion = getDocVersion(key);
									if(!force){
										if(curVersion !== store[key].version){
											dfd.reject('versionconflict', key);
											return
										}
									}
									
									store[key].key = key;
									store[key].version += 1;
									store[key].timestamp = unixtime();
									
									//check if the data is the same as the documentObject else replace the item of the documentObject
									if(data != store[key]){
										store[key].item = data;
									}
								}
								else {
									store[key] = {key:key, version:1, timestamp:unixtime(), item:data};
								}
							
								localStorage.setItem(key, createStringFromObject(store[key]));
								if(keys.indexOf(key) === -1){
									keys.push(key);
								}
								localStorage.setItem(DBkey, JSON.stringify(keys));
								dfd.resolve(key);
								
							}).promise();
						},
						
						delete : function(key, force){
							var store = self.bases[dbName][objectStoreName];
							var keys = self.keys[dbName][objectStoreName];
							var DBkey = DBkeyGen(dbName, objectStoreName);
							var idx = -1;
							
							return $.Deferred(function(dfd){
								if(store[key]){
									var curVersion = getDocVersion(key);
									if(!force){
										if(curVersion !== store[key].version){
											dfd.reject('versionconflict', key);
											return
										}
									}
								
									delete store[key];
									idx = keys.indexOf(key);
									if(idx !== -1){
										keys.splice(idx, 1);
									}
									localStorage.setItem(DBkey, JSON.stringify(keys));
									localStorage.removeItem(key);
									dfd.resolve(key);
								}
							}).promise();
						},
						
						getKeys : function(){
							return self.keys[dbName][objectStoreName].slice(0);
						},
												
						objectStore : function(){
							return self.bases[dbName][objectStoreName];
						}
					}
				}
			};
		}
	})
})(jQuery);